﻿using System.Collections.Generic;
using System.Net.Http;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Polly.Registry;
using SimmyBreakingYourOwnCode.Model;
using SimmyBreakingYourOwnCode.Service;

namespace SimmyBreakingYourOwnCode.Controllers
{
    [Produces("application/json")]
    [Route("api/[controller]")]
    public class RandomValueController : Controller
    {
        private readonly IHttpClientFactory _httpClientFactory;

        private readonly RandomValueGenerator _randomValueGenerator;

        public RandomValueController(IHttpClientFactory httpClientFactory, IPolicyRegistry<string> policyRegistry, RandomValueGenerator randomValueGenerator)
        {
            _httpClientFactory = httpClientFactory;
            _randomValueGenerator = randomValueGenerator;
        }
        [HttpGet("Number")]
        public IActionResult GetNumber()
        {
            return Ok(_randomValueGenerator.GetRandomNumber());
        }
        
        [HttpGet("NameAndLength")]
        public IActionResult GetNameAndLength()
        {
            return Ok(_randomValueGenerator.GetNameAndLength());
        }

        [HttpGet("Name")]
        public IActionResult GetName()
        {
            return Ok(_randomValueGenerator.GetRandomName());
        }
    }
}
