﻿using Polly.Contrib.Simmy;
using Polly.Contrib.Simmy.Fault;
using Polly.Registry;
using SimmyBreakingYourOwnCode.Model;
using System;
using System.Collections.Generic;

namespace SimmyBreakingYourOwnCode.Service
{
    public class RandomValueGenerator
    {
        InjectOutcomePolicy _faultPolicy = MonkeyPolicy.InjectFault(
            new Exception("Simmy threw an exception"),
            injectionRate: .5,
            enabled: () => true
        );

        InjectOutcomePolicy<NameAndLength> _corruptDataPolicy = MonkeyPolicy.InjectFault<NameAndLength>(
            new NameAndLength { Name = "xxxxx", Lenght = -100 },
            injectionRate: .5,
            enabled: () => true
        );

        public string GetRandomName()
        {
            return _faultPolicy.Execute(() => names[_random.Next(0, 5)]);
        }

        public int GetRandomNumber()
        {
            return _faultPolicy.Execute(() => _random.Next(0, 100));
        }

        public NameAndLength GetNameAndLength()
        {
            string name = names[_random.Next(0, 5)];
            NameAndLength nameAndLength = new NameAndLength { Name = name, Lenght = name.Length };
            return _corruptDataPolicy.Execute(() => nameAndLength);
        }

        public RandomValueGenerator()
        {
            _random = new Random();
        }

        private readonly Random _random;
        List<string> names = new List<string>() { "Andrew", "Betty", "Colm", "Dave", "Eve", "Francis" };

    }
}
